/*********************************************/
/*       File name:  session.c               */
/*    Project name:  socket/mtalk2           */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ߥŻҲĥ饤ȤΥå⥸塼 */
/* ǡ                                 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <curses.h>
#include "mtalk2.h"

#define MYNAME_LENGTH 12
#define SEND_WIN_WIDTH 60
#define SEND_WIN_HEIGHT 1
#define RECV_WIN_WIDTH 60
#define RECV_WIN_HEIGHT 13

static char   send_buf[BUF_LEN];  /* Хåե */
static char   *input_buf;
static char   recv_buf[BUF_LEN];  /* Хåե */
static int    soc;                /* socket  */
static fd_set mask;               /* fd mask */
static int    width;              /* width of the mask */
static struct sockaddr_in  server;
static struct sockaddr_in  me;
static struct sockaddr_in  from;
static int    fromlen;
static char   myname[MYNAME_LENGTH]; /* ʬ̾ */
static int    my_slot;

/*  ѤȼѤΥɥʬ */
static WINDOW *win_send, *win_recv;
static WINDOW *frame_send, *frame_recv;

/* */
static void   die();
static int    login();
static void   logout();

int session_setupclient(char *hostname, in_port_t port)
	/* hostname  ФΥۥ̾   */
	/* port      ФΥݡֹ */
{
	struct	hostent	*server_ent;

	/* ФΥɥ쥹  */
	if((server_ent = gethostbyname(hostname)) == NULL){
		perror("gethostbyname");
		return -1;
	}

	memset((char *)&server, 0, sizeof(server));
	server.sin_family = AF_INET;
	server.sin_port = htons(port);
	memcpy((char *)&server.sin_addr, server_ent->h_addr,
	       server_ent->h_length);

	/* ǡѤΥåȤ */
	if ((soc = socket(AF_INET,SOCK_DGRAM,0)) < 0 ){
		perror("socket");
		return -1;
	}

	/* ʬΥɥ쥹ΥХ */
	memset((char *)&me, 0, sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = 0;

	if (bind(soc ,&me,sizeof(me)) == -1){
		perror("bind");
		return -1;
	}
	printf("successfully bound.\n");
	return login();
}

/*  */
static int login()
{
	send_buf[0] = LOGIN;
	printf("Your name?");
	fgets(myname, MYNAME_LENGTH, stdin);
	chop_newline(myname, MYNAME_LENGTH);

	strcpy(send_buf + 1, myname);
	sendto(soc, send_buf, strlen(send_buf)+1, 0,
	       &server, sizeof(server));
	fromlen=sizeof(from);
	recvfrom(soc, recv_buf, BUF_LEN, 0, &from, &fromlen);

	if ((u_char)recv_buf[0] == CANNOT_LOGIN){
		printf("cannot login\n");
		return -1;
	}else if ((u_char)recv_buf[0] == LOGIN_OK){
		sscanf(recv_buf+1, "%02d", &my_slot);
		send_buf[0] = DATA;
		sprintf(send_buf + 1,"%-10s-> ",myname);
		input_buf = send_buf + 14;
		printf("You have logged in.\n");
		return 1;
	}else{
		printf("recv_buf[0]==%u", (u_char)recv_buf[0]);
		return -2;
	}
}


/*  åν  */
void session_init()
{
	/* select ѥޥ    */
	width = soc+1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	FD_SET(soc, &mask);

	/* curses νʤ  */
	initscr();
	signal(SIGINT, die);

	/* ɥȤĤ */
	frame_send = newwin( SEND_WIN_HEIGHT + 2, SEND_WIN_WIDTH + 2, 18, 0);
	win_send = newwin( SEND_WIN_HEIGHT, SEND_WIN_WIDTH, 19, 1);
	box(frame_send, '|', '-');
	scrollok(win_send, TRUE);
	wmove(win_send, 0,0);

	frame_recv = newwin(RECV_WIN_HEIGHT + 2, RECV_WIN_WIDTH + 2, 0, 0);
	win_recv = newwin(RECV_WIN_HEIGHT, RECV_WIN_WIDTH, 1, 1);
	box(frame_recv, '|', '-');
	scrollok(win_recv, TRUE);
	wmove(win_recv, 0,0);

	/* ü°ѹ */
	cbreak();
	noecho();

	/* ɥɽ */
	wrefresh(frame_recv);
	wrefresh(win_recv);
	wrefresh(frame_send);
	wrefresh(win_send);
}

/*  åΥᥤ롼  */
void session_loop()
{
	int    c, flag;
	fd_set readOk;
	int    len;
	int    i;     /* loop counter */
	int    y,x;   /* coordinates */
	int    n;     /* number of bytes being read */


	flag= 1;      /* 롼׷³ΤΥեå  */
	len = 0;      /* input_buf θ߰ */

	while(1){
		/*  select  readOk 롣 */
		readOk = mask;
		select(width,(fd_set *)&readOk,NULL,NULL,NULL);

		/*  ܡɤϤ꤫ */
		if ( FD_ISSET(0, &readOk ) ){
			c = getchar();

			/* back space ν */
			if (c == '\b'|| c==0x10 || c==0x7F){
				if (len == 0) continue;
				len--;
				getyx(win_send, y,x);
				wmove(win_send, y, x-1);
				waddch(win_send, ' ');
				wmove(win_send, y, x-1);
			}

			/* Ԥ */
			else if (c == '\n' || c == '\r'){
				input_buf[len++]='\n';
				sendto(soc,send_buf,len + 14,
				       0, &server, sizeof(server));

				/* Clearing the send window */
				wclear(win_send);
				len = 0;
			}
			/* ʳν */
			else{
				input_buf[len++]=c;
				waddch(win_send, c);
			}
			wrefresh(win_send);
		}

		/*  åȤ˥ǡ꤫ */
		if ( FD_ISSET(soc, &readOk ) ){
			fromlen=sizeof(from);
			n = recvfrom(soc,recv_buf,BUF_LEN,0,
			             &from, &fromlen);

			if ((u_char)recv_buf[0]==DATA){
				for (i=1; i<n; i++)
				waddch(win_recv, recv_buf[i]);
			}

			/* END 齪λ */
			else if ((u_char)recv_buf[0]==END)
			flag=0;
			wrefresh(win_recv);
			/* Move cursor back to the send buffer */
			wrefresh(win_send);
		}

		if(flag == 0) break;
	}
	/* ü°줷ƽ */
	die();
}


/* λ */
static void die()
{
	endwin();
	logout();
	close(soc);
	exit();
}

/* Ƚ */
static void logout()
{
	send_buf[0]=LOGOUT;
	sprintf(send_buf+1, "%02d\n", my_slot);

	sendto(soc,send_buf,4,
		 0, &server, sizeof(server));
}
