/*********************************************/
/*       File name:  race.h                  */
/*    Project name:  socket/race             */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <sys/types.h>
#include <netinet/in.h>

#define MAX_PLAYERS  5

/* each player's information is encoded in PLAYER_SIZE octets */
#define PLAYER_SIZE  4

/* offsets in PLAYER_SIZE octets */
#define STAGE        0
#define XPOS         1
#define YPOS         2
#define DAMAGE       3

/* each player's grade is encoded in GRADE_SIZE octets */
#define GRADE_SIZE  16

/* offsets in GRADE_SIZE octets */
#define ENTRYNUM     0
#define ENTRYNAME    1

/* Parameters */
#define MAX_STAGES  10
#define STAGE_LENGTH 20
#define STAGE_WIDTH  10

#define MAX_DAMAGE  10
#define PORT     (in_port_t)50003
#define HOSTNAME_LENGTH 64
#define FILENAME_LENGTH 64
#define BUF_LENGTH 64

#define NORTH 'k'
#define SOUTH 'j'
#define EAST  'l'
#define WEST  'h'
