/*********************************************/
/*       File name:  session.c               */
/*    Project name:  socket/race             */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* 졼󥰥Υå⥸塼 */

#include <curses.h>
#include <signal.h>
#include "race.h"

static char p[MAX_PLAYERS * PLAYER_SIZE]; /* ٤ƤΥץ졼   */
static char temp[PLAYER_SIZE];            /* ʬξ() */
static char g[MAX_PLAYERS * GRADE_SIZE];  /* ٤ƤΥץ졼 */

static int num;         /* üԿ       */
static int final;       /*  ơ    */
static int soc;         /*  å      */
static int entry_num;   /*  ȥֹ  */
static int flag;        /* ʬξ     */
static int final_state; /* ʬκǽ */

static char    *me;         /* ʬξؤΥݥ */

static WINDOW  *win1, *win2; /* ɽѥɥ */

/*  level 2 δؿ  */

static int  get_my_location();
static void send_my_data();
static void del_all_locations();
static void show_all_locations();
static void recv_all_data();
static int  new_stage(int z);

/*  level 3 δؿ  */
static void init_data();
static int  check(int a, int b);
static void ending(int how);

/*  ʥϥɥ */
static void die();

/* åν  */

void session_init(int s)
	/* s  å */
{
	char buf[BUF_LENGTH];    /* ,Хåե */
	soc = s;                 /* åȤΥǥץ */

	/* ³ľΡ֥ */
	read(soc, buf, BUF_LENGTH);
	printf(buf);
	fgets(buf, BUF_LENGTH, stdin);  /* ü̾ */
	chop_newline(buf, BUF_LENGTH);

	write(soc, buf, strlen(buf)+1); /* ̾ */
	read(soc, buf, BUF_LENGTH);
	sscanf(buf, "%d", &entry_num );
	printf("Your entry number is %d\n", entry_num);
	read(soc, buf, BUF_LENGTH);     /* triger Ԥ */
	sscanf(buf, "%d %d", &num, &final);
	printf("players are %d\n", num);
	printf("final stage is  %d\n", final);

	/* ʥ */
	signal(SIGINT,die);
	signal(SIGQUIT,die);
	signal(SIGTERM,die);
	signal(SIGSEGV,die);
	signal(SIGPIPE,die);

	/* curses ν */
	initscr();
	noecho();
	crmode();
	nonl();

	/* ɥκ */
	win1=newwin(22,12,1,10); /* ɽ       */
	win2=newwin(11,25,5,40); /* 졼ξɽ */
	box(win1,'|','-');
	box(win2,'|','-');

	/* 裱ơǡɤ߹ */
	new_stage(1);

	/* ǡ */
	init_data();

	/* 졼νɽ */
	mvwprintw(win2,2,1,"Entry Num=%d",entry_num);
	mvwprintw(win2,3,2,"num  stage  damage");
	mvwprintw(win2,entry_num+4,1,"*");

	/* ɽ */
	show_all_locations();
}

/* åΥ롼 */
void session_loop()
{
	flag = 1;

	while (flag){
		flag = get_my_location();  /* ʬΰư         */
		send_my_data();            /* ʬΥǡ         */
		del_all_locations();       /* ٤ƤΥץ졼ä     */
		recv_all_data();           /* ٤ƤΥǡ   */
		show_all_locations();      /* ʬΥơˤ
		                              ٤ƤΥץ졼ɽ */
	}
	ending(final_state);         /* λ */
	die();
}


/*************/
/* level 2   */
/*************/

/* ʬΰư */
static int get_my_location()
{
	int c;  /* ư */

	c = getchar();

	switch(c){
	case	WEST:
		if (check(-1,0)==1)
		    temp[XPOS]--;
		 else
			temp[DAMAGE]++;
		break;
	case	SOUTH:
		if (check(0,1)==1)
		    temp[YPOS]++;
	else
			temp[DAMAGE]++;
	break;
	case	NORTH:
		if (temp[YPOS] == (char)1){
			temp[STAGE]++;          /* Υơ */
			temp[YPOS] = (char) 21; /* ΥơΥȥ饤 */
			if (new_stage((int) temp[STAGE])==0){
				final_state = 0;
				return	0;
			}
		}
		else if (check(0,-1)==1)
			temp[YPOS]--;
			else
	    temp[DAMAGE]++;
	  break;
	case	EAST:
		if (check(1,0)==1)
		    temp[XPOS]++;
		else
		    temp[DAMAGE]++;
		break;
	default:
	  break;
	}

	if(temp[DAMAGE]>=MAX_DAMAGE){
		final_state = -1;
		return	0;
	}
	return	1;
}

/* ʬΥǡ */
static void send_my_data()
{
	write(soc,&temp,PLAYER_SIZE);
}

/* ʬΥơˤ뤹٤ƤΥץ졼ä */
static void del_all_locations()
{
	int	i;

	for (i=0; i<num; i++){
		if (p[i * PLAYER_SIZE + STAGE] == me[STAGE]){
			mvwaddch(win1, p[i * PLAYER_SIZE + YPOS],
			         p[i * PLAYER_SIZE + XPOS], ' ');
		}
	}
	touchwin(win1);
	wrefresh(win1);
}

/* ٤ƤΥǡ򥵡Ф */
static void recv_all_data()
{
	read(soc, p, PLAYER_SIZE * num);
}

/* ʬΥơΤ٤ƤΥץ졼ɽ */
static void show_all_locations()
{
	int	i;

	for(i=0; i<num; i++){
		if (p[i * PLAYER_SIZE + STAGE] == me[STAGE])
			mvwaddch(win1, p[i * PLAYER_SIZE + YPOS],
			         p[i * PLAYER_SIZE + XPOS], (char)(i+0x30) );
	}
	touchwin(win1);
	wrefresh(win1);

	mvwprintw(win2,9,2,"stage=%2d/%2d", (int)me[STAGE], final);
	for(i=0; i<num; i++)
		mvwprintw(win2,i+4,2," %2d  %2d     %2d ",
		          i, (int)p[i * PLAYER_SIZE + STAGE],
		             (int)p[i * PLAYER_SIZE + DAMAGE]);

	wrefresh(win2);
}

/* ꥹơΥǡɤ߹ */
static int new_stage(int z)
	/*    0ʤ齪 */
	/* z       ơֹ */
{
	FILE *fp;
	int   i;
	static char buf[16];

	if (z > final) return 0;

	sprintf(buf,"data/data%d",z);
	fp=fopen(buf,"r");
	for(i=1;i<=STAGE_LENGTH;i++){
		fgets(buf,16,fp);
		buf[10]='\0';
		wmove(win1,i,1);
		waddstr(win1,buf);
	}
	fclose(fp);
	return 1;
}

/* λ */
static void ending(int how)
{
	int	i;

	wclear(win2);
	box(win2,'|','-');
	if (how == 0)
		mvwprintw(win2,1,3,"Goal in, Wait!");
	else
		mvwprintw(win2,1,3,"Crashed, Wait!");
	wrefresh(win2);

	read(soc,g,GRADE_SIZE * num);
	for(i=0;i<num;i++){
		mvwprintw(win2,i+3,1,"[%d] %d: %s",
		          i+1,
		          (int)g[i * GRADE_SIZE + ENTRYNUM],
		          &g[i * GRADE_SIZE + ENTRYNAME]);
	}
	wrefresh(win2);
	getchar();
}


/*************/
/* level 3   */
/*************/

/* ǡν */
static void init_data()
{
	int	i;

	me = p + PLAYER_SIZE * entry_num;
	for(i=0;i<num;i++){
		p[i * PLAYER_SIZE + STAGE] = (char)1;
		p[i * PLAYER_SIZE + XPOS] = (char)(2+i);
		p[i * PLAYER_SIZE + YPOS] = (char)20;
		p[i * PLAYER_SIZE + DAMAGE] = (char)0;
	}
	memcpy(temp, me, PLAYER_SIZE);
}

/* 㳲ʪؤξͤ䥳ȤΥå */
static int check(int a, int b)
	/*    1ϰ   0ϰưԲ */
	/* a,b ư                 */
{
	int	p,q;

	p = temp[XPOS] + a;
	q = temp[YPOS] + b;

	if (p<1 || p>STAGE_WIDTH || q<1 || q>STAGE_LENGTH+1)
		return  0;

	/* mvwinch  chtype (maybe u_long)֤
	   ʸФˤ
	   Υӥåȱ黻ɬס                 */

	if( (A_CHARTEXT & mvwinch(win1, q, p))=='*')
		return  0;
	return  1;
}

/*************/
/* emergency */
/*************/


/* ʥӽλ */
static void die()
{
	endwin();
	echo();
	exit(1);
}
