/*********************************************/
/*       File name:  session.c               */
/*    Project name:  socket/tag              */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <sys/types.h>
#include <curses.h>
#include <signal.h>

#define BUF_LEN 20
#define MIN_X	1
#define MIN_Y	1
#define MAX_X	60
#define MAX_Y	20

/* ưγ */
#define NORTH 'k'
#define SOUTH 'j'
#define EAST  'l'
#define WEST  'h'
#define QUIT  'q'

/* ץ饤١ѿ */
static  int    session_soc;     /* socket  */
static  fd_set mask;            /* fd mask */
static  int    width;           /* width of the mask */
static  char   my_char, peer_char; /* character */

typedef	struct{
	int	x,y; /* current position */
	char	look;  /* character */
} PLAYER;

static PLAYER me, peer;    /* ʬξ֤ݻѿ  */

static char buf[BUF_LEN];  /* ѥХåե */

static WINDOW *win;	   /* ɽѥɥ */

/*  session ⥸塼˥ץ饤١Ȥʴؿ  */
static void hide(PLAYER *who);
static void show(PLAYER *who);
static int  update(PLAYER *who, int c);
static int  interpret(PLAYER *who);
static void die();

/*  session ⥸塼ν  */
void session_init(int soc,
                  char mc, int mx, int my,
                  char pc, int px, int py)
	   /* soc  åȤΥǥץ */
	   /* mc   ʬɽѤʸ       */
	   /* mx   ʬνxɸ          */
	   /* my   ʬνyɸ          */
	   /* pc   ɽѤʸ       */
	   /* px   νxɸ          */
	   /* py   νyɸ          */
{
/* ǡ */
	session_soc = soc;
	width = soc + 1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	FD_SET(session_soc, &mask);
	me.look = mc;
	peer.look = pc;

	me.x = mx;  me.y = my;
	peer.x = px;  peer.y = py;

	/* curses ν */
	initscr();
	signal(SIGINT, die);

	/* ɥ */
	win = newwin(MAX_Y + 2, MAX_X + 2, 0, 0);
	box(win, '|', '-');

	/* ü */
	cbreak();
	noecho();
}


/*  session ᥤ롼  */
void session_loop()
{
	int c;         /* ܡɤʸ */
	int flag;      /* 롼׷³եå       */
	fd_set readOk; /* ¿ϤΥޥ         */

	/* ʬλѤɽ */
	show(&me);

	/* 롼׷³եåν */
	flag = 1;

	/* 롼 */
	while(1){
		/*  select  readOk 롣 */
		readOk = mask;
		select(width,(fd_set *)&readOk,NULL,NULL,NULL);

		/*  ܡɤϤ꤫ */
		if ( FD_ISSET(0, &readOk ) ){
			c = getchar();            /* ܡɤ     */
			hide(&me);                /* ʬλѤ򱣤         */
			flag = update(&me, c);    /* ֤򹹿             */
			show(&me);                /* ʬλѤ򸽤         */
			write(session_soc, buf, BUF_LEN); /* ǡ */
			if(flag == 0) break;      /* 롼ȴФȽ     */
		}

		 /*  åȤ˥ǡ꤫ */
		if ( FD_ISSET(session_soc, &readOk ) ){
			read(session_soc,buf,BUF_LEN); /* åȤ  */
			hide(&peer);              /* λѤ򱣤         */
			flag = interpret(&peer);  /* ξ֤ι       */
			show(&peer);              /* λѤ򸽤         */
			if(flag == 0) break;      /* 롼ȴФȽ     */
		}

	}
	/* ü°줷ƽ */
	die();
}


static void show(PLAYER *who)
	/* who  ïɽ뤫  */
{
	wmove(win, who->y, who->x); /* whoξư           */
	waddch(win, who->look);     /* ξwholook֤ */
	wmove(win, who->y, who->x); /* ᤹            */
	wrefresh(win);              /* ɥι          */
}


static void hide(PLAYER *who)
	/* who  ïλѤä  */
{
	wmove(win, who->y, who->x); /* whoξư           */
	waddch(win, ' ');           /* ξ˥ڡ  */
}


static int update(PLAYER *who, int c)
	/* who  ï             */
	/* c    ɤư */
{
	switch(c){
	case WEST:
		if ( who->x > MIN_X )
			who->x--;
		break;
	case SOUTH:
		if ( who->y < MAX_Y )
			who->y++;
		break;
	case NORTH:
		if ( who->y > MIN_X )
			who->y--;
		break;
	case EAST:
		if ( who->x < MAX_X )
			who->x++;
		break;
	case QUIT:
		buf[0]=QUIT;
		return 0;
	default:
		break;
	}

	/* 줿֥ǡʸѴ */
	sprintf(buf, "%d %d\n", who->x, who->y);
	return 1;
}

static int interpret(PLAYER *who)
	/* who ΥǡγǼؤ */
{
	/* ⤷꤬λ˾ */
	if (buf[0] == 'q')
		return 0;

	/* ʸ󤫤֥ǡѴ롣 */
	sscanf(buf, "%d %d", &who->x, &who->y);
	return 1;
}

static void die()
{
	endwin();  /* ü° */
	exit(0);
}
